#version 450

layout (location = 0) in vec3 inPos;


layout (binding = 0) uniform UniformBuffer {
	vec4 color;
	mat4 modelMatrix;
	mat4 modelMatrixForNormals;
	mat4 viewProjMatrix;
	vec4 cameraPosition;
	vec4 illumination; // ka, kd, ks, alpha
	float brightness;
	float time;
} ub_data;

layout (binding = 1) uniform DirectionalLight {
	vec4 color;
	vec4 direction;
	mat4 depthViewProjMatrix;

} dl_data;

layout (binding = 2) uniform PointLight {
	vec4 color;
	vec4 position;
	vec4 attenuation;
} pl_data;

out gl_PerVertex 
{
    vec4 gl_Position;   
};

 
void main()
{
	gl_Position = ( dl_data.depthViewProjMatrix * ub_data.modelMatrix )  * vec4(inPos, 1.0);
}